diff --git a/bin/varnishd/cache/cache_backend_probe.c b/bin/varnishd/cache/cache_backend_probe.c
index c99b0abea5..c87c73465c 100644
--- a/bin/varnishd/cache/cache_backend_probe.c
+++ b/bin/varnishd/cache/cache_backend_probe.c
@@ -409,6 +409,17 @@ vbp_poke(struct vbp_target *vt)
 		vt->happy |= 1;
 }
 
+/*--------------------------------------------------------------------
+ */
+static void
+vbp_heap_insert(struct vbp_target *vt)
+{
+	// Lck_AssertHeld(&vbp_mtx);
+	binheap_insert(vbp_heap, vt);
+	if (binheap_root(vbp_heap) == vt)
+		AZ(pthread_cond_signal(&vbp_cond));
+}
+
 /*--------------------------------------------------------------------
  */
 
@@ -438,8 +449,7 @@ vbp_task(struct worker *wrk, void *priv)
 		if (vt->heap_idx != BINHEAP_NOIDX) {
 			vt->due = VTIM_real() + vt->interval;
 			binheap_delete(vbp_heap, vt->heap_idx);
-			binheap_insert(vbp_heap, vt);
-			AZ(pthread_cond_signal(&vbp_cond));
+			vbp_heap_insert(vt);
 		}
 	}
 	Lck_Unlock(&vbp_mtx);
@@ -638,8 +648,7 @@ VBP_Control(const struct backend *be, int enable)
 	if (enable) {
 		assert(vt->heap_idx == BINHEAP_NOIDX);
 		vt->due = VTIM_real();
-		binheap_insert(vbp_heap, vt);
-		AZ(pthread_cond_signal(&vbp_cond));
+		vbp_heap_insert(vt);
 	} else {
 		assert(vt->heap_idx != BINHEAP_NOIDX);
 		binheap_delete(vbp_heap, vt->heap_idx);
